"use strict";

{
    self.C3.Plugins.BHT_Smart_Random.Acts =
        {
            Randomize()
            {
                console.log("Randomize()");
                this.Regenerate(true);
            }
            ,
            New(start, end, threshold)
            {
                console.log("New()");
                this.StartValue = start;
                this.EndValue = end;
                this.Threshold = threshold;

                this.DataWidth = (this.EndValue - this.StartValue) + 1;

                if (this.Threshold >= this.DataWidth)
                {
                    // It isn't possible to have a threshold >= the data-width, so we will just ignore the value.
                    console.log("Threshold is illegal. Ignoring it!");
                    this.Threshold = 0;
                }

                this.DataArray = new Array(this.DataWidth);			// The actual randomized data
                this.TempArray = new Array(this.DataWidth);			// The initial sequential data that we randomly pull from.
                this.ThresholdArray = new Array(this.Threshold);	// A copy of the last data array so we can eliminate "threshold" duplicates.

                this.CurrentIndex = 0;

                this.Regenerate(true);
            }
        };
}